# syntax=docker-registry.wikimedia.org/repos/releng/blubber:v0.17.0

version: v4
base: docker-registry.wikimedia.org/nodejs20-slim
lives:
  in: /srv/service
runs:
  environment: { APP_BASE_PATH: /srv/service }

variants:
  build:
    base: docker-registry.wikimedia.org/nodejs20-slim
    copies: [local]
    apt: { packages: [git, build-essential, python3, pkg-config] }
    node: { requirements: [package.json] }
  development:
    includes: [build]
    apt: { packages: [ca-certificates, curl, kafkacat, telnet, iputils-ping, procps, curl, vim] }
    entrypoint: [node, server.js]
    runs: { environment: { APP_CONFIG_PATH: ./config.yaml } }
  test:
    includes: [build]
    apt: { packages: [ca-certificates] }
    entrypoint: [npm, test]
    # Needed so that tests can write cache and coverage info in /srv/service
    runs: { insecurely: true }
  prep:
    includes: [build]
    node: { env: production }
  production:
    copies: [prep]
    node: { env: production }
    entrypoint: [node, server.js]
    runs: { environment: { APP_CONFIG_PATH: ./config.yaml } }
